import binascii, subprocess, socket, commands
from scapy.all import *

#### Config

sIntf="wwan0"
sHaapName="haap.t-online.de"
sCIN = binascii.unhexlify("5370656564706f72745f4879627269645f3035303132345f30325f30305f30313200000000000000ff0000")
#sCIN = binascii.unhexlify("5370656564706f72745f4879627269645f3035303132345f30335f30305f303132")

#### Variables

sKey=""
sFirstHaap=""
sHaapIP=""
sGetIPV6cmd="ifconfig "+sIntf+" |  awk '/inet6/{print $3}' | grep 2a01"
sLocIPV6=commands.getstatusoutput(sGetIPV6cmd)[1][:-3]


#### HELPER-Functions

def byte_to_binary(n):
    return ''.join(str((n & (1 << i)) and 1) for i in reversed(range(8)))

def hex_to_binary(h):
    return ''.join(byte_to_binary(ord(b)) for b in binascii.unhexlify(h))

def sendCMD(cmd):
    process = subprocess.Popen(cmd.split(), stdout=subprocess.PIPE)
    output, error = process.communicate()

def setTunnels(sGREloc,sGRErem,sGREkey):
    global sHaapIP

    sendCMD("sudo ip -6 tunnel del greLTE1")
    sendCMD("sudo ip -6 link del greLTE1")
    #sendCMD("sudo ip -6 route del default dev wwan0")
    sendCMD("sudo ip -6 route add 2003:6:1000::1/128 dev "+sIntf)
    sendCMD("sudo ip -6 route add "+sGRErem+"/128 dev "+sIntf)
    #sendCMD("sudo ip -6 route add default dev greLTE1")
    sendCMD("sudo ip -6 tunnel add greLTE1 mode ip6gre remote "+sGRErem+" local "+sGREloc+" dev "+sIntf+" key "+sGREkey)
    #sendCMD("sudo ip -6 link add greLTE3 type ip6gretap remote "+sGRErem+" local "+sGREloc+" key "+sGREkey)
    sendCMD("sudo ip -6 route add default dev greLTE1")
    sendCMD("sudo ip -6 link set greLTE1 up")
    #sendCMD("sudo ifconfig greLTE1 inet6 add 2003:6:1fe:5200:5a2a:f7ff:fec6:2e36/128")
    #sendCMD("sudo ifconfig greLTE1 87.132.58.188")
    #sendCMD("sudo ip -6 link set greLTE1 arp on")
    #sendCMD("sudo ip link set greLTE1 arp on")
    #sendCMD("sudo ip link set greLTE1 multicast on")
    #sendCMD("sudo ip -6 link set greLTE1 multicast on")


#### String-Functions DT-HAAP

def getMsgType(msgtype):
    return {
        1: 'GRE Setup Request',
	2: 'GRE Setup Accept',
	3: 'GRE Setup Deny',
	4: 'GRE Hello',
	5: 'GRE Tear Down',
	6: 'GRE Notify', }.get(msgtype,"Unknown / Reserved")

def getTunType(tuntype):
    return {
        0: 'DSL-Tunnel',
        1: 'LTE-Tunnel', }.get(tuntype,"Error!")

def getAttType(atttype):
    return {
        3: 'CIN',
        4: 'Session ID',
        5: 'Timestamp',
        6: 'Bypass Traffic Rate',
        8: 'Filter List Package',
        9: 'RTT Difference Threshold', 
	10: 'Bypass Bandwidth Check Interval',
        11: 'Switching to DSl Tunnel',
        12: 'Overflowing to LTE Tunnel',
        14: 'Hello Interval',
        15: 'Hello Retry Times',
        16: 'Idle Timeout',
	17: 'Error Code',
        18: 'DSL Link Failure',
        19: 'LTE Link Failure',
        21: 'IPv6 Prefix Assigned to Terminal Host',
        22: 'Subscribed DSL Upstream BW',
        23: 'Subscribed DSL Downstram BW',
        24: 'Delay Difference Threshold Violation',
        25: 'Delay Difference Threshold Compliance',
        30: 'Filter list ACK',
        255: 'END AVP',}.get(atttype,"Unknown / Reserved")


#### SendMessage

##New Fields for Packet Type "DTGRE" (Deutsche Telekom Hybrid GRE Protocol)
class DTGRE(Packet):
    name = "DTGRE"
    fields_desc = [ BitField("chksum_present",0,1),
                    BitField("routing_present",0,1),
                    BitField("key_present",0,1),
                    BitField("seqnum_present",0,1),
                    BitField("strict_route_source",0,1),
                    BitField("recursion control",0,3),
                    BitField("flags",0,5),
                    BitField("version",0,3),
                    XShortEnumField("proto", 0x0000, ETHER_TYPES),
                    ConditionalField(XShortField("chksum",None), lambda pkt:pkt.chksum_present==1 or pkt.routing_present==1),
                    ConditionalField(XShortField("offset",None), lambda pkt:pkt.chksum_present==1 or pkt.routing_present==1),
                    ConditionalField(XIntField("key",None), lambda pkt:pkt.key_present==1),
                    ConditionalField(XIntField("seqence_number",None), lambda pkt:pkt.seqnum_present==1),
                    #New Fields for DT
                    BitField("MsgType",0,4),
                    BitField("T",0,1),
                    BitField("Res",0,3),
                    BitField("AttType",0,8),
                    BitField("AttLen",0,16),
                ]


def sendMsg(sDst,sKey_Present,sMSGKey,sMsgType,sAttType,sAttLen,sAttVal):
    #Create Packet | Sending AttVal as RAW
    DT_Haap = (IPv6()/DTGRE()/Raw(load=sAttVal))

    #IPv6-Setup
    DT_Haap.dst=sDst
    DT_Haap.nh=47

    #DTGRE-Setup
    DT_Haap.key_present=sKey_Present
    DT_Haap.proto=0x0101
    DT_Haap.MsgType=sMsgType
    DT_Haap.T=0
    DT_Haap.AttType=sAttType
    DT_Haap.AttLen=sAttLen
    DT_Haap.key=sMSGKey

    print "!!!!! Sending Packet to "+sDst
    #Send Packet
    send(DT_Haap)
    print "!!!!!"


#### Listener-Code

def packetReceived(packet):
    global sHaapIP
    global sKey

    #packet.get("Raw").encode("hex")
    pkt_hexstr = str(packet[Raw]).encode("hex")
    pkt_binstr = hex_to_binary(pkt_hexstr)
    pkt_data   = pkt_binstr.split("00100000000000000000000100000001",1)[1]
    pkt_key    = pkt_data[:32]
    pkt_attr   = pkt_data[32:]

    print "+++++ HYBRID PACKET DETECTED +++++"
    
    print "Time-Received:		"+time.strftime("%H:%M:%S")
    print "IP-Source:           	"+packet[IPv6].src
    print "IP-Destination:		"+packet[IPv6].dst
    
    print "Key (Decimal):		"+hex(int(pkt_key, 2))   

    nMsgType = int(pkt_attr[0:4],2)
    print "Message-Type:		"+str(nMsgType)+" - "+str(getMsgType(nMsgType))

    nTunType = int(pkt_attr[4])
    print "Tunnel-Type:		"+str(nTunType)+" - "+str(getTunType(nTunType))
       
    nAttType = int(pkt_attr[8:16],2)
    print "Attribute-Type:		"+str(nAttType)+" - "+str(getAttType(nAttType))

    print "----------------------------------"

    if nMsgType == 2:
	sKey = str(int(pkt_key, 2))
	#sKeyHex = sKeyHex[:-1]
	#sKeyHex = sKeyHex[2:0]
        #sKey = str(int(sKeyHex,16))

        print "Starting Hello Messages!"
        f = open('_key','w')
	f.write(sKey+'\n')
        f.close()
	#print binascii.hexlify(pkt_key)
	print "\033[92m!! Got Key !! = "+sKey+"\033[0m" 
	sHaapIP = packet[IPv6].src
    if packet[IPv6].src != sHaapIP:
	    global sFirstHaap
	    if sFirstHaap != packet[IPv6].src:
		sFirstHaap = packet[IPv6].src
		print "\033[92m!! Setup Tunnel !! = "+sKey #+"\033[0m"
		print "Loc: "+sLocIPV6
		print "Rem: "+sFirstHaap+"\033[0m"
		f = open('_haaprouter','w')
        	f.write(sFirstHaap+'\n')
        	f.close()
		setTunnels(sLocIPV6,sFirstHaap,sKey)

    if nMsgType == 6 and nAttType == 8:
	nComit = int(pkt_attr[32:64],2)
	print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
	sVal = pkt_attr[32:64] + "00000000111111110000000000000000"
	sValHex = hex(int(sVal, 2))
	sValHex = sValHex[:-1]
	sValSend = binascii.unhexlify(sValHex[2:])
	print sValSend
	sendMsg(sFirstHaap,1,int(sKey),6,30,5,sValSend)


    return


#### Program-Code

sendCMD("sudo ip -6 route add default dev wwan0")

## Send GRE Setup Packet to Haap
sendMsg(sHaapName,1,0,1,3,40,sCIN)

## Setup sniff, filtering for IP traffic
sniff(iface="wwan0",filter="proto 47 and dst host "+sLocIPV6,prn=packetReceived)
